/*
 * Created by victoria on 2021-05-12.
 */

#include "device_service.h"
#include "device.h"

using namespace QXmpp::Omemo;

DeviceService::DeviceService(QObject *parent) : QObject(parent) {}

void DeviceService::onDeviceListReceived(const QString &jid, const QXmpp::Omemo::DeviceList &list) {

    for (const auto &device : list.devices) {
        qInfo() << "Got device for" << jid << ":" << device.id;
    }
}

QSharedPointer<Database> DeviceService::getDatabase(const QString &jid) {
    if (!databases.contains(jid)) {
        databases.insert(jid, QSharedPointer<Database>::create(jid));
    }

    return databases[jid];
}

void DeviceService::addIdentity(const QString &jid, int deviceId, const QByteArray& publicKey) {
    auto db = getDatabase(jid);

    db->saveIdentityKey(deviceId, publicKey);
}

void DeviceService::onDeviceListNotFound(const QString &jid) {
    qInfo() << "Device list not found:" << jid;
}
