/*
 * Created by victoria on 2021-05-12.
 */

#pragma once

#include <QBuffer>

#include "qomemo.h"
#include "user_device_list.h"
#include "database.h"

#include <QXmppClient.h>

namespace QXmpp::Omemo {

    class DeviceList;

    class DeviceService : public QObject {
    Q_OBJECT

    public:
        explicit DeviceService(QObject *parent);

        QSharedPointer<Database> getDatabase(const QString& jid);

    public slots:
        void addIdentity(const QString& jid, int deviceId, const QByteArray& publicKey);

        void onDeviceListReceived(const QString &jid, const QXmpp::Omemo::DeviceList &list);

        void onDeviceListNotFound(const QString &jid);

    private:
        QMap<QString, QSharedPointer<Database>> databases{};
    };

} // namespace QXmpp::Omemo
