/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include "omemo_base.h"

namespace QXmpp::Omemo::Variant {

    class Conversations : public Base {
    public:
        ~Conversations() override = default;

        QXmppElement deviceToXml(const Device &device) override;
        Device deviceFromXml(const QXmppElement &xml) override;

        [[nodiscard]] QString getDeviceListNode() const override;
        QXmppElement deviceListToXml(const DeviceList &deviceList) override;
        std::optional<DeviceList> latestDeviceListFromPubSubNode(const QXmppElement &items) override;
        QXmppIq deviceListSetIq(const DeviceList &deviceList) override;

        QXmppElement preKeyToXml(const PreKey &pk) override;
        std::optional<PreKey> preKeyFromXml(const QXmppElement &xml) override;

        QXmppElement bundleToXml(const Bundle &bundle) override;
        std::optional<Bundle> bundleFromXml(const QXmppElement &xml) override;

        QXmppIq bundleSetIq(int deviceId, const Bundle &bundle) override;
    };

} // namespace QXmpp::Omemo::Variant
